static const char *copyright = "copyright (c) 2011 Victor Milenkovic and Elisha Sacks.  Permission required for commercial use.  Contact vjm@cs.miami.edu";

#include "PolyArc.h"

int nn1 = 0, nn2 = 0, nn3 = 0, nn4 = 0;
double btime = 0.0;

int main (int argc, char *argv[]) {
  Parameter::enable();
  double scale = atof(argv[2]);
  cout << "scale " << scale << endl;

  if (argc == 5) {
    double delta = atof(argv[4]);
    cout << "delta " << delta << endl;
    Parameter::delta = delta;
  }

  PolyArc *poly = new PolyArc(argv[1]);
  poly->drawFig("poly.fig");  

  PolyArc *conv = new PolyArc(poly, scale);
  conv->drawFig("conv.fig");

  PolyArc *level = conv->levelSet();
  level->drawFig("level.fig");

  if (argc == 4)
    level->write(argv[3]);

  if (argc == 5)
    level->write(argv[3], conv->o->getX().value());

  return 0;
}
