#ifndef IMPLICIT
#define IMPLICIT

#include "acp.h"

class PFun {
 public:
  virtual bool extended () const = 0;
  virtual Parameter value (const Parameter &x) const = 0;
  virtual Parameter der (const Parameter &x) const = 0;
  Parameter polish (const Parameter &x) const;
};

class PFunPoly : public PFun {
 public:
  PFunPoly (int di, Parameter *ai = 0);
  PFunPoly (const PFunPoly &f);
  ~PFunPoly () {delete [] a; }
  PFunPoly & operator= (const PFunPoly &f);
  bool extended () const { return a[0].extended(); }
  Parameter value (const Parameter &x) const;
  Parameter der (const Parameter &x) const;
  PFunPoly partial () const;
  void increasePrecision ();
  void decreasePrecision ();

  int d;
  Parameter *a;
};

int implicit (const PFunPoly &f, double lb, double ub, Parameter *res);

int implicit2 (const PFunPoly &f, double lb, double ub, Parameter *res);

Parameter implicit (double a, const PFun *f, double lb, double ub);

double findBracket (double a, const PFun *f, int sb, double b);

Parameter shrinkBracket (const PFun *f, int sub, double lb, double ub);

Parameter shrinkBracketB (const PFun *f, const Parameter &x, int sub);

#endif

