#include "sum.h"

int main (int argc, char *argv[])
{
  if (argc < 3)
    return 0;
  string aname = argv[1], bname = argv[2];
  ifstream astr(aname.c_str()), bstr(bname.c_str());
  if (!astr.good() || !bstr.good()) 
    return 0;
  double delta = argc < 4 ? 1e-8 : atof(argv[3]);
  int precision = argc < 5 ? 250 : atoi(argv[4]);
  Parameter::enable();
  Parameter::delta = delta;
  Parameter::precision = precision;
  Polyhedron *a = readPolyhedron(astr), *b = readPolyhedron(bstr);
  double t0 = getTime(), dmin = 1e-6;
  Polyhedron *c = minkowskiSum(a, b, 1e-6, false);
  double t1 = getTime() - t0;
  int nf = c->faces.size();
  cerr << nf << " " << t1 << endl;
  //c->output(VTK, cout);
  delete a;
  delete b;
  delete c;
  Parameter::disable();
  return 0;
}
