#ifndef PPOLY
#define PPOLY

#include "acp.h"

class PPoly {
 public:
  PPoly () : nv(0), nt(0), a(0), m(0) {}
  PPoly (int inv, int nti) : nv(inv), nt(nti), 
    a(new Parameter [nti]), m(new int [inv*nti]) {}
  PPoly (int inv, int nti, Parameter *ia, int *im);
  PPoly (const PPoly &p);
  void setDegree ();
  ~PPoly () {delete [] a; delete [] m; }
  PPoly & operator= (const PPoly &p);
  int degree () const { return d; }
  bool extended () const { return a[0].l == Sentinel; }
  Parameter value (Parameter *x) const;
  Parameter der (Parameter *x, int dn) const;
  PPoly partial (int i) const;
  PPoly homogenize () const;
  void increasePrecision ();
  void decreasePrecision ();

  int nv, nt, d;
  Parameter *a;
  int *m;
};

#endif
